Log::Emitter - Crystal 1.5.0

# struct Log::Emitter

- Log::Emitter
- Struct
- Value
- Object

##
Overview

Helper DSL module for emitting log entries with data.

##
Defined in:

log/main.cr

##
Instance Method Summary

- #emit(message : String, data : Metadata | Hash | NamedTuple) : Entry
- #emit(message : String) : Entry

  Emits a logs entry with a message, and data attached to

- #emit(data : Metadata | Hash | NamedTuple) : Entry
- #emit(message : String, **kwargs) : Entry
- #emit(**kwargs) : Entry

### Instance methods inherited from struct `Struct`

==(other) : Bool ==, hash(hasher) hash, inspect(io : IO) : Nil inspect, pretty_print(pp) : Nil pretty_print, to_s(io : IO) : Nil to_s

### Instance methods inherited from struct `Value`

==(other : JSON::Any)
==(other : YAML::Any)
==(other) ==, dup dup

### Instance methods inherited from class `Object`

! : Bool !, !=(other) !=, !~(other) !~, ==(other) ==, ===(other : JSON::Any)
===(other : YAML::Any)
===(other) ===, =~(other) =~, as(type : Class) as, as?(type : Class) as?, class class, dup dup, hash(hasher)
hash hash, in?(collection : Object) : Bool
in?(*values : Object) : Bool in?, inspect(io : IO) : Nil
inspect : String inspect, is_a?(type : Class) : Bool is_a?, itself itself, nil? : Bool nil?, not_nil! not_nil!, pretty_inspect(width = 79, newline = "\n", indent = 0) : String pretty_inspect, pretty_print(pp : PrettyPrint) : Nil pretty_print, responds_to?(name : Symbol) : Bool responds_to?, tap(&) tap, to_json(io : IO) : Nil
to_json : String to_json, to_pretty_json(indent : String = " ") : String
to_pretty_json(io : IO, indent : String = " ") : Nil to_pretty_json, to_s(io : IO) : Nil
to_s : String to_s, to_yaml(io : IO) : Nil
to_yaml : String to_yaml, try(&) try, unsafe_as(type : T.class) forall T unsafe_as

### Class methods inherited from class `Object`

from_json(string_or_io, root : String)
from_json(string_or_io) from_json, from_yaml(string_or_io : String | IO) from_yaml

##
Instance Method Detail

def emit(message : String, data : Metadata | Hash | NamedTuple) : Entry #
def emit(message : String) : Entry #

Emits a logs entry with a message, and data attached to

    Log.info &.emit("Program started")                         # No data, same as Log.info { "Program started" }
    Log.info &.emit("User logged in", user_id: 42)             # With entry data
    Log.info &.emit(action: "Logged in", user_id: 42)          # Empty string message, only data
    Log.error exception: ex, &.emit("Oops", account: {id: 42}) # With data and exception

def emit(data : Metadata | Hash | NamedTuple) : Entry #
def emit(message : String, **kwargs) : Entry #
def emit(**kwargs) : Entry #